<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;
use HCM\Util\FPA;

class GpeSitevento extends \Doctrine\ORM\EntityRepository {
    
    public function retornaSitEvento($mes_competencia){
        
        $gpeSitevento = Repositories::GPE_SITEVENTO;
        $nrorg = FPA::getNrorgTrabalho();
        $nrorgPadrao = FPA::getNrorgPadrao();
        
        $params = array('p_dtmescompetenc' => $mes_competencia->format('d/m/Y'), 'p_nrorg' => $nrorg, 'p_nrorg_padrao' => $nrorgPadrao);
        
$query = <<<SQL
    SELECT i
		FROM $gpeSitevento i
		INNER JOIN $gpeSitevento se WITH 
     se.dtmescompetenc = (
			SELECT MAX(x.dtmescompetenc)
  			FROM $gpeSitevento x
  			WHERE x.dtmescompetenc <= :p_dtmescompetenc 
        AND se.nreventom = x.nreventom
        AND se.nrsitufuncm = x.nrsitufuncm	
        AND x.nrorg = i.nrorg
  		)
    AND se.nreventom = i.nreventom
		AND se.nrsitufuncm = i.nrsitufuncm	
		AND se.nrorg = i.nrorg
		WHERE 
		(i.nrorg = :p_nrorg or i.nrorg = :p_nrorg_padrao) AND
        i.idgeraevento = 'S'
		ORDER BY i.nrsitufuncm, i.nreventom
SQL;

        return $this->getEntityManager()->createQuery($query)->execute($params);
    }
    
}